--[[ Manual Cutting
Author:	Ifko[nator] überarbeitet t0xic0m
Datum:	25.08.2015
Bearbeitungs Datum:	10.04.2016

Version:	v1
]]

Harvester = {};

local cuttedTrees = 0;

function Harvester.prerequisitesPresent(specializations) 
    return SpecializationUtil.hasSpecialization(WoodHarvester, specializations);
end; 


function Harvester:load(xmlFile)
	WoodHarvester.onDelimbTree = Utils.overwrittenFunction(WoodHarvester.onDelimbTree, Harvester.NEWonDelimbTree);
	
	self.cutMaxRadius = 0.68;

    self.cutLengthMin = 1;
    self.cutLengthMax = 18;
    self.cutLengthStep = 1;
end;

function Harvester:delete()
end;

function Harvester:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Harvester:keyEvent(unicode, sym, modifier, isDown)
end;

function Harvester:NEWonDelimbTree(onDelimbTree, state) 
    self.isAttachedSplitShapeMoving = state;
    
	if not state then
		if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA2) then
			self:cutTree(0);
		end;
    end;
end;


function Harvester:update(dt)
	if self:getIsActiveForInput(true) and self:getIsTurnedOn() then
		if self.cutNode ~= nil then
			if self.hasAttachedSplitShape then
				if not self.isAttachedSplitShapeMoving and self:getAnimationTime(self.cutAnimation.name) == 1 then
					if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA2) then
						self:cutTree(self.currentCutLength);
					end
				end
				elseif self.curSplitShape ~= nil then
					if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA2) then
						self:cutTree(0);
						cuttedTrees = cuttedTrees + 1;
						--print(cuttedTrees)
					end
				end
			end
		end

end;

function Harvester:draw()
	if self:getIsTurnedOn() then
		if self:getIsActive() then
			local CuttedTreesString = string.format(Harvester.CUTTED_TREES, cuttedTrees);
			
			renderText(g_currentMission.fillLevelIconOverlay.x + 2*g_currentMission.fillLevelTextOffsetX, g_currentMission.speedHud.y, g_currentMission.fillLevelTextSizeSmall, CuttedTreesString);
		end;
	end;
end;

function Harvester:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
	if not resetVehicles then
		cuttedTrees = Utils.getNoNil(getXMLFloat(xmlFile, key .. "#cuttedTrees"), cuttedTrees);
		
		cuttedTrees = cuttedTrees;
	end;

	return BaseMission.VEHICLE_LOAD_OK;
end;

function Harvester:getSaveAttributesAndNodes(nodeIdent)
    local attributes = 'cuttedTrees="'.. tostring(cuttedTrees) .. '"';

	return attributes, nil;
end;